
import java.io.IOException;
import java.util.HashMap;
import java.util.StringTokenizer;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapreduce.*;
import org.apache.hadoop.mapreduce.lib.output.*;
import org.apache.hadoop.mapreduce.lib.input.*;

public class MatrixVectorMult {
	
	static class FirstMap extends Mapper<LongWritable, Text, Text, Text> {
	
		protected void map(LongWritable key, Text value, Context context) 
			throws IOException, InterruptedException
			{
				
				// TO DO
			
			}
		}
	

	static class FirstReduce extends Reducer<Text, Text, Text, DoubleWritable> {
		private DoubleWritable partialResult = new DoubleWritable ();
		protected void reduce(Text key, Iterable<Text> values, Context context) throws IOException, InterruptedException{
			
			HashMap<Integer,Double> matrixColumn = new HashMap<Integer,Double> ();
			
			// TO DO
		}
	}
	
	
	static class SecondMap extends Mapper<Text, Text, Text, Text> {
		
		protected void map(Text key, Text value, Context context) 
			throws IOException, InterruptedException
			{
				
				// TO DO
			
			}
		}
	
	
	static class CombinerForSecondMap extends Reducer<Text, Text, Text, Text> {
		private Text partialResult = new Text();
		protected void reduce(Text key, Iterable<Text> values, Context context) throws IOException, InterruptedException{
			
			// TO DO
		}
	}
	
	
	static class SecondReduce extends Reducer<Text, Text, Text, DoubleWritable> {
		private DoubleWritable finalResult = new DoubleWritable ();
		protected void reduce(Text key, Iterable<Text> values, Context context) throws IOException, InterruptedException{
			
			// TO DO
		}
	}
	
	
	public static void launchJob(String input, String intermediary, String output)
			throws IOException, ClassNotFoundException, InterruptedException {
		Configuration conf = new Configuration();
		// First job
		Job job1 = Job.getInstance(conf);
		job1.setMapOutputKeyClass(Text.class);
		job1.setMapOutputValueClass(Text.class);

		job1.setMapperClass(FirstMap.class);
		job1.setReducerClass(FirstReduce.class);

		job1.setInputFormatClass(TextInputFormat.class);
		job1.setOutputFormatClass(TextOutputFormat.class);

		FileInputFormat.setInputPaths(job1, new Path(input));
		FileOutputFormat.setOutputPath(job1, new Path(intermediary));

		job1.waitForCompletion(true);
		
		// Second job
		Job job2 = Job.getInstance(conf);
		job2.setMapOutputKeyClass(Text.class);
		job2.setMapOutputValueClass(Text.class);

		job2.setMapperClass(SecondMap.class);
		job2.setReducerClass(SecondReduce.class);
		
		// If your implementation of the combinet passed the unit test, uncomment the following line
		// job2.setCombinerClass(CombinerForSecondMap.class);
		
		job2.setInputFormatClass(KeyValueTextInputFormat.class);
		job2.setOutputFormatClass(TextOutputFormat.class);

		FileInputFormat.setInputPaths(job2, new Path(intermediary));
		FileOutputFormat.setOutputPath(job2, new Path(output));

		job2.waitForCompletion(true);
	}
	
}

